<?xml version="1.0" encoding="utf-8"?>
<Project xmlns="http://schemas.microsoft.com/developer/msbuild/2003" Sdk="Microsoft.NET.Sdk">

  <PropertyGroup Label="Product">
    <!-- Most properties are defined in the .nuspec file, which is required to explicitly set dependencies. The Pack
         task does not support merging an existing .nuspec file nor provides any means to have an influence on the
         .nuspec file generation. Some projects such as .NET Arcade instead generate common properties as an XML string 
         that is inserted via a replacement token.
         https://github.com/NuGet/Home/issues/6321#issuecomment-352119364
         https://github.com/tmat/arcade/blob/d4ce4704d0bd5ae2e37024817580744ad23f86c2/src/Microsoft.DotNet.Arcade.Sdk/tools/Workarounds.targets#L64
         
         To simplify things, project properties except for global properties are directly configured in the .nuspec file,
         including contained file paths. Other properties are passed explicity via replacement tokens that are passed
         during the SetNuspecPropertiesFromProjectProperties target.
     -->
    <NuspecFile>$(MSBuildProjectName).nuspec</NuspecFile>
    <!-- Versioning. -->
    <VersionPrefix>1.1.0</VersionPrefix>
    <RepositoryType>git</RepositoryType>
  </PropertyGroup>

  <PropertyGroup Label="Build Configuration">
    <TargetFramework>netstandard1.0</TargetFramework>
    <!-- Omit the compiled library from the NuGet package such that it only contains the MSBuild targets. -->
    <IncludeBuildOutput>false</IncludeBuildOutput>
    <NoPackageAnalysis>true</NoPackageAnalysis>
    <!-- Package only contains MSBuild props and targets and does not depend on a framework.
         Also avoids warning NU5128 that is otherwise emitted. -->
    <SuppressDependenciesWhenPacking>true</SuppressDependenciesWhenPacking>
  </PropertyGroup>

  <ItemGroup Label="Packages">
    <PackageReference Include="XploRe.Versioning.Tools.DotNet" Version="0.3.0" PrivateAssets="All" />
  </ItemGroup>

  <Target Name="SetNuspecPropertiesFromProjectProperties" BeforeTargets="GenerateNuspec">
    <!-- Collect .nuspec file replacement tokens via an item list for convenience and readability. -->
    <ItemGroup>
      <NuspecProperty Include="id" Value="$(MSBuildProjectName)" />
      <!-- Global. -->
      <NuspecProperty Include="licenseExpression" Value="$(PackageLicenseExpression)" />
      <NuspecProperty Include="icon" Value="$(PackageIcon)" />
      <NuspecProperty Include="iconUrl" Value="$(PackageIconUrl)" />
      <NuspecProperty Include="copyright" Value="$(Copyright)" />
      <!-- Versioning. -->
      <NuspecProperty Include="version" Value="$(Version)" />
      <NuspecProperty Include="repositoryBranch" Value="$(RepositoryBranch)" />
      <NuspecProperty Include="repositoryCommit" Value="$(RepositoryCommit)" />
    </ItemGroup>

    <!-- Flatten .nuspec file replacement tokens into semicolon-separated list that is processed by the NuGet Pack task. -->
    <PropertyGroup>
      <NuspecProperties>@(NuspecProperty->'%(Identity)=%(Value)', ';')</NuspecProperties>
    </PropertyGroup>

    <Message Importance="high" Text="Nuspec %24%(NuspecProperty.Identity)%24 = %(NuspecProperty.Value)" />
  </Target>

</Project>
